---
title: DataTransferItem.webkitGetAsEntry()
slug: Web/API/DataTransferItem/webkitGetAsEntry
tags:
  - API
  - DataTransferItem
  - File System API
  - File and Directory Entries API
  - Files
  - Method
  - Non-standard
  - Offline
  - Reference
  - drag and drop
  - getAsEntry
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}{{Non-standard_header}}</p>

<p>If the item described by the {{domxref("DataTransferItem")}} is a file, <code>webkitGetAsEntry()</code> returns a {{domxref("FileSystemFileEntry")}} or {{domxref("FileSystemDirectoryEntry")}} representing it. If the item isn't a file, <code>null</code> is returned.</p>

<div class="note">
<p>This function is implemented as <code>webkitGetAsEntry()</code> in non-WebKit browsers including Firefox at this time; it may be renamed to <code>getAsEntry()</code> in the future, so you should code defensively, looking for both.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>DataTransferItem</em>.webkitGetAsEntry();</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("FileSystemEntry")}}-based object describing the dropped item. This will be either {{domxref("FileSystemFileEntry")}} or {{domxref("FileSystemDirectoryEntry")}}.</p>

<h2 id="Example">Example</h2>

<p>In this example, a drop zone is created, which responds to the {{event("drop")}} event by scanning through the dropped files and directories, outputting a hierarchical directory listing.</p>

<h3 id="HTML_content">HTML content</h3>

<p>The HTML establishes the drop zone itself, which is a {{HTMLElement("div")}} element with the ID <code>"dropzone"</code>, and an unordered list element with the ID <code>"listing"</code>.</p>

<pre class="brush: html notranslate">&lt;p&gt;Drag files and/or directories to the box below!&lt;/p&gt;

&lt;div id="dropzone"&gt;
  &lt;div id="boxtitle"&gt;
    Drop Files Here
  &lt;/div&gt;
&lt;/div&gt;

&lt;h2&gt;Directory tree:&lt;/h2&gt;

&lt;ul id="listing"&gt;
&lt;/ul&gt;</pre>

<h3 id="CSS_content">CSS content</h3>

<p>The styles used by the example are shown here.</p>

<pre class="brush: css notranslate">#dropzone {
  text-align: center;
  width: 300px;
  height: 100px;
  margin: 10px;
  padding: 10px;
  border: 4px dashed red;
  border-radius: 10px;
}

#boxtitle {
  display: table-cell;
  vertical-align: middle;
  text-align: center;
  color: black;
  font: bold 2em "Arial", sans-serif;
  width: 300px;
  height: 100px;
}

body {
  font: 14px "Arial", sans-serif;
}</pre>

<h3 id="JavaScript_content">JavaScript content</h3>

<p>First, let's look at the recursive <code>scanFiles()</code> function. This function takes as input a {{domxref("FileSystemEntry")}} representing an entry in the file system to be scanned and processed (the <code>item</code> parameter), and an element into which to insert the list of contents (the <code>container</code> parameter).</p>

<div class="notecard note">
<p>Note that to read all files in a directory, <code>readEntries</code> needs to be called repeatedly until it returns an empty array. In Chromium-based browsers, the following example will only return a max of 100 entries.</p>
</div>

<pre class="brush: js notranslate">let dropzone = document.getElementById("dropzone");
let listing = document.getElementById("listing");

function scanFiles(item, container) {
  let elem = document.createElement("li");
  elem.textContent = item.name;
  container.appendChild(elem);

 if (item.isDirectory) {
    let directoryReader = item.createReader();
    let directoryContainer = document.createElement("ul");
    container.appendChild(directoryContainer);
    directoryReader.readEntries(function(entries) {
        entries.forEach(function(entry) {
          scanFiles(entry, directoryContainer);
      });
    });
  }
}
</pre>

<p><code>scanFiles()</code> begins by creating a new {{HTMLElement("li")}} element to represent the item being scanned, inserts the name of the item into it as its text content, and then appends it to the container. The container is always a list element in this example, as you'll see shortly.</p>

<p>Once the current item is in the list, the item's {{domxref("FileSystemEntry.isDirectory", "isDirectory")}} property is checked. If the item is a directory, we need to recurse into that directory. The first step is to create a {{domxref("FileSystemDirectoryReader")}} to handle fetching the directory's contents. That's done by calling the item's {{domxref("FileSystemDirectoryEntry.createReader", "createReader()")}} method. Then a new {{HTMLElement("ul")}} is created and appended to the parent list; this will contain the directory's contents in the next level down in the list's hierarchy.</p>

<p>After that, {{domxref("FileSystemDirectoryReader.readEntries", "directoryReader.readEntries()")}} is called to read in all the entries in the directory. These are each, in turn, passed into a recursive call to <code>scanFiles()</code> to process them. Any of them which are files are inserted into the list; any which are directories are inserted into the list and a new level of the list's hierarchy is added below, and so forth.</p>

<p>Then come the event handlers. First, we prevent the {{event("dragover")}} event from being handled by the default handler, so that our drop zone can receive the drop:</p>

<pre class="brush: js notranslate">dropzone.addEventListener("dragover", function(event) {
    event.preventDefault();
}, false);
</pre>

<p>The event handler that kicks everything off, of course, is the handler for the {{event("drop")}} event:</p>

<pre class="brush: js notranslate">dropzone.addEventListener("drop", function(event) {
  let items = event.dataTransfer.items;

  event.preventDefault();
  listing.textContent = "";

  for (let i=0; i&lt;items.length; i++) {
    let item = items[i].webkitGetAsEntry();

    if (item) {
        scanFiles(item, listing);
    }
  }
}, false);</pre>

<p>This fetches the list of {{domxref("DataTransferItem")}} objects representing the items dropped from <code>event.dataTransfer.items</code>. Then we call {{domxref("Event.preventDefault()")}} to prevent the event from being handled further after we're done.</p>

<p>Now it's time to start building the list. First, the list is emptied by setting {{domxref("Node.textContent", "listing.textContent")}} to be empty. That leaves us with an empty {{domxref("ul")}} to begin inserting directory entries into.</p>

<p>Then we iterate over the items in the list of dropped items. For each one, we call its {{domxref("DataTransferItem.webkitGetAsEntry", "webkitGetAsEntry()")}} method to obtain a {{domxref("FileSystemEntry")}} representing the file. If that's successful, we call <code>scanFiles()</code> to process the item—either by adding it to the list if it's just a file or by adding it and walking down into it if it's a directory.</p>

<h3 id="Result">Result</h3>

<p>You can see how this works by trying it out below. Find some files and directories and drag them in, and take a look at the resulting output.</p>

<p>{{ EmbedLiveSample('Example', 600, 400) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-datatransferitem-webkitgetasentry', 'webkitGetAsEntry()') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransferItem.webkitGetAsEntry")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("DataTransferItem")}}</li>
 <li>{{domxref("FileSystemEntry")}}, {{domxref("FileSystemFileEntry")}}, and {{domxref("FileSystemDirectoryEntry")}}</li>
 <li>Events: {{event("dragover")}} and {{event("drop")}}</li>
</ul>
